@echo off
set target=%SystemDrive%
set "repo=%~dp0Updates"
set "dismroot=%windir%\system32\dism.exe"
set LDRbranch=ON
set IE11=ON
set RDP=ON
set Hotfix=ON
set Features=OFF
set WAT=OFF
set WMF=OFF
set Windows10=OFF
set win10u=ON
set ADLDS=OFF
set RSAT=OFF
set onlinelimit=75

set servicestack=KB3020369
set rollup=KB3125574
set gdrlist=(KB2574819,KB2685811,KB2685813)
set rdp8=(KB2984976,KB3020387,KB3075222)
set hv_integ_kb=hypervintegrationservices
set hv_integ_vr=9600.18398

set "cab_dir=%temp%\cab"

:: ##################################################################
:: # NORMALY THERE IS NO NEED TO CHANGE ANYTHING BELOW THIS COMMENT #
:: ##################################################################

if exist "%target%\Windows\SysWOW64\cmd.exe" (set arch=x64) else (set arch=x86)

set _reg=%windir%\system32\reg.exe
%_reg% query "HKU\S-1-5-19" 1>nul 2>nul || (
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo.
echo ADMINISTRATOR PRIVILEGES NOT DETECTED!
echo __________________________________________________________________
echo.
echo This script must be run with administrator privileges!
echo To do so, right click on it and select 'Run as administrator'
echo.
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

:mainmenu
cls
echo ==================================================================
if /i "%target%"=="%SystemDrive%" (echo 1. Target   ^(%arch%^) : Current Online OS) else (echo 1. Target   ^(%arch%^) : "%target%")
echo.
echo 2. WHD Repository : "%repo%"
echo.
echo 3. LDR branch     : %LDRbranch%
echo 4. IE11           : %IE11%
echo 5. RDP            : %RDP%
echo 6. Hotfixes       : %Hotfix%
echo 7. Features       : %Features%
echo 8. WMF            : %WMF%
echo A. WAT ^(KB971033^) : %WAT%
if /i %Windows10% equ OFF (echo W. Windows10      : %Windows10%) else (echo W. Windows10      : %Windows10%        / B. Block Windows10 upgrade: %win10u%)
echo S. ADLDS          : %ADLDS%
echo R. RSAT           : %RSAT%
if /i "%target%" neq "%SystemDrive%" (echo.&echo D. DISM : "%dismroot%")
if /i "%target%" equ "%SystemDrive%" (echo.&echo 9. Online installation limit: %onlinelimit% updates)
echo ==================================================================
echo 0. Start the process
echo ==================================================================
echo.
choice /c 1234567890DAWSRBX /n /m "Change a menu option, press 0 to start, or X to exit: "
if errorlevel 17 goto :eof
if errorlevel 16 (if /i %win10u% equ ON (set win10u=OFF) else (set win10u=ON))&goto :mainmenu
if errorlevel 15 (if /i %RSAT% equ ON (set RSAT=OFF) else (set RSAT=ON))&goto :mainmenu
if errorlevel 14 (if /i %ADLDS% equ ON (set ADLDS=OFF) else (set ADLDS=ON))&goto :mainmenu
if errorlevel 13 (if /i %Windows10% equ ON (set Windows10=OFF) else (set Windows10=ON))&goto :mainmenu
if errorlevel 12 (if /i %WAT% equ ON (set WAT=OFF) else (set WAT=ON))&goto :mainmenu
if errorlevel 11 goto :dismmenu
if errorlevel 10 goto :mainboard
if errorlevel 9 goto :countmenu
if errorlevel 8 (if /i %WMF% equ ON (set WMF=OFF) else (set WMF=ON))&goto :mainmenu
if errorlevel 7 (if /i %Features% equ ON (set Features=OFF) else (set Features=ON))&goto :mainmenu
if errorlevel 6 (if /i %Hotfix% equ ON (set Hotfix=OFF) else (set Hotfix=ON))&goto :mainmenu
if errorlevel 5 (if /i %RDP% equ ON (set RDP=OFF) else (set RDP=ON))&goto :mainmenu
if errorlevel 4 (if /i %IE11% equ ON (set IE11=OFF) else (set IE11=ON))&goto :mainmenu
if errorlevel 3 (if /i %LDRbranch% equ ON (set LDRbranch=OFF) else (set LDRbranch=ON))&goto :mainmenu
if errorlevel 2 goto :repomenu
if errorlevel 1 goto :targetmenu
goto :mainmenu

:targetmenu
cls
echo.
echo Enter the location of target offline image/mount directory, then press enter.
echo.
set /p target=
if not exist "%target%\Windows\explorer.exe" (
echo.
echo ==================================================================
echo ERROR: Selected location is not valid Windows image
echo ==================================================================
echo.
echo Press any key to continue.
pause >nul
set target=%SystemDrive%
)
if exist "%target%\Windows\SysWOW64\cmd.exe" (set arch=x64) else (set arch=x86)
goto :mainmenu

:repomenu
cls
echo.
echo Enter the location of WHD "Updates" folder, then press enter.
echo.
set /p repo=
goto :mainmenu

:countmenu
cls
echo.
echo Enter the updates count limit for online installation, then press enter.
echo.
set /p onlinelimit=
goto :mainmenu

:dismmenu
cls
echo.
echo Enter the location of Custom dism.exe path, then press enter.
echo.
set /p dismroot=
goto :mainmenu

:mainboard
cls
if "%target:~-1%"=="\" set "target=%target:~0,-1%"
set dismtarget=/image:"%target%"
if /i "%target%"=="%SystemDrive%" (set "dismtarget=/online"&set online=1)

if "%repo:~-1%"=="\" set "repo=%repo:~0,-1%"
set "repo=%repo%\Windows7-%arch%"
if not exist "%repo%\*" (
set "repo=%~dp0Updates"
echo.
echo ==================================================================
echo ERROR: Selected repository location is not valid
echo ==================================================================
echo.
echo Press any key to continue.
pause >nul
goto :mainmenu
)

dir /b "%target%\Windows\servicing\Version\6.1.7601*" 1>nul 2>nul || (
echo.
echo ==================================================================
echo ERROR: Detected target online/offline image is not Windows 7 SP1
echo ==================================================================
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

if defined online (
for /f "skip=2 tokens=3 delims= " %%i in ('%_reg% query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v EditionID') do set CEdition=%%i
) else (
%_reg% load HKLM\OFFSOFT "%target%\Windows\System32\config\SOFTWARE" >nul
for /f "skip=2 tokens=3 delims= " %%i in ('%_reg% query "HKLM\OFFSOFT\Microsoft\Windows NT\CurrentVersion" /v EditionID') do set CEdition=%%i
%_reg% unload HKLM\OFFSOFT >nul
)

set allcount=0
set IEcab=0
setlocal enableextensions
setLocal EnableDelayedExpansion
call :baseline
if defined online call :online
call :general
if /i %IE11% equ ON (call :ie11) else (call :ie9)
call :security
if /i %RDP% equ ON call :rdp
if /i %Hotfix% equ ON call :hotfix
if /i %Features% equ ON call :features
if /i %WMF% equ ON call :wmf
if /i %Windows10% equ ON call :windows10
if /i %Windows10% equ ON if /i %win10u% equ ON call :win10u
if /i %Hotfix% equ ON call :regfix
if /i %ADLDS% equ ON call :adlds
if /i %RSAT% equ ON call :rsat
goto :fin

:baseline
if not exist "%repo%\General\*%servicestack%*-%arch%.msu" goto :eof
if exist "%target%\Windows\servicing\packages\package_for_%servicestack%*6.1*.mum" goto :eof
if defined online if exist "%windir%\winsxs\pending.xml" (goto :stacklimit)
call :cleaner
title Servicing stack update
cd General\
cls
echo.
echo Installing %servicestack%
echo __________________________________________________________________
echo.
for /f "delims=" %%i in ('dir /b "*%servicestack%*-%arch%.msu"') do expand.exe -f:*Windows*.cab "%%i" "%cab_dir%" >nul
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:"%cab_dir%"
goto :eof

:general
if not exist "%repo%\General\*.msu" goto :eof
call :cleaner
title Processing General Updates
cls
md "%cab_dir%\General"
if /i %WAT% equ ON if exist "Additional\WAT\*%arch%*.msu" (expand.exe -f:*Windows*.cab Additional\WAT\*%arch%*.msu "%cab_dir%\General" >nul)
if /i %RDP% neq ON if not exist "%target%\Windows\servicing\packages\*RDP-*-Package*.mum" if exist "Extra\WithoutKB3125574\WithoutRDP\*%arch%*.msu" (expand.exe -f:*Windows*.cab Extra\WithoutKB3125574\WithoutRDP\*%arch%*.msu "%cab_dir%\General" >nul)
pushd General\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\General" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\General" >nul)
popd
pushd Extra\WithoutKB3125574\#General\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\General" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\General" >nul)
popd
cd /d "%cab_dir%\General"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\General"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=General Updates
goto :listdone

:security
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Security\*.msu" goto :eof
call :cleaner
title Processing Security Updates
cls
md "%cab_dir%\Security"
pushd Security\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\Security" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\Security" >nul)
popd
pushd Extra\WithoutKB3125574\#Security\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\Security" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\Security" >nul)
popd
cd /d "%cab_dir%\Security"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\Security"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Security Updates
goto :listdone

:hotfix
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Hotfix\*.msu" goto :eof
call :cleaner
title Processing Hotfixes
cls
md "%cab_dir%\Hotfix"
if exist "Additional\WMF\Windows6.1-KB2819745-%arch%-MultiPkg.msu" (expand.exe -f:Windows6.1-KB2872035-%arch%.cab Additional\WMF\Windows6.1-KB2819745-%arch%-MultiPkg.msu "%cab_dir%\Hotfix" >nul)
if /i %CEdition% EQU Enterprise if exist "%target%\Windows\fr-fr\explorer.exe.mui" if exist "Extra\WithoutKB3125574\SL\French.Enterprise\*%arch%*.msu" (copy Extra\WithoutKB3125574\SL\French.Enterprise\*%arch%*.msu "%cab_dir%\Hotfix" >nul)
if exist "%target%\Windows\pl-pl\explorer.exe.mui" if exist "Extra\WithoutKB3125574\SL\Polish\*%arch%*.msu" (copy Extra\WithoutKB3125574\SL\Polish\*%arch%*.msu "%cab_dir%\Hotfix" >nul)
pushd Hotfix\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\Hotfix" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\Hotfix" >nul)
popd
pushd Extra\WithoutKB3125574\#Hotfix\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\Hotfix" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\Hotfix" >nul)
popd
cd /d "%cab_dir%\Hotfix"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\Hotfix"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Hotfixes
goto :listdone

:rdp
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\RDP\*.msu" goto :eof
call :cleaner
title Processing RDP Updates
cls
md "%cab_dir%\RDP"
pushd Additional\RDP\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\RDP" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\RDP" >nul)
popd
pushd Extra\WithoutKB3125574\_RDP\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\RDP" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\RDP" >nul)
popd
cd /d "%cab_dir%\RDP"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\RDP"
for /f %%G in ('dir /b *.cab') do (call :mum %%G)
set cat=RDP Updates
goto :listdone

:ie11
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\_IE11\*" goto :eof
call :cleaner
title Processing IE11 Updates
cls
md "%cab_dir%\IE11"
cd Additional\_IE11\
for /f "delims=" %%a in ('"dir /b /s *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\IE11" >nul)
for /f "delims=" %%a in ('"dir /b /s *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\IE11" >nul)
cd /d "%cab_dir%\IE11"
call :counter
if %_sum% equ 0 goto :eof
set IEcab=1
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_msu% neq 0 (set msu=1&set count=0&for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
set IEcab=0
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\IE11"
for /f %%G in ('dir /b *.cab') do (call :mum %%G)
set cat=IE11 Updates
goto :listdone

:ie9
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if exist "%target%\Windows\servicing\packages\*InternetExplorer*11.2.*.mum" goto :eof
if not exist "%repo%\Extra\IE9\*.msu" if not exist "%repo%\Extra\IE8\*.msu" goto :eof
call :cleaner
title Processing IE Updates
cls
if exist "Extra\IE9\*.msu" (
md "%cab_dir%\IE9"
cd Extra\IE9\
for /f "delims=" %%a in ('"dir /b /s *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\IE9" >nul)
cd /d "%cab_dir%\IE9"
set IEcab=1
) else (
cd Extra\IE8
)
call :counter
if %_sum% equ 0 (set IEcab=0&goto :eof)
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
set IEcab=0
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b *.cab') do (call :mum %%G)
set cat=IE Updates
goto :listdone

:features
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Extra\WithoutKB3125574\_Features\*" goto :eof
call :cleaner
title Processing Features Hotfixes
cls
cd Extra\WithoutKB3125574\_Features\
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Features Hotfixes
goto :listdone

:windows10
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\Windows10\*.msu" goto :eof
call :cleaner
title Processing Windows10 related Updates
cls
md "%cab_dir%\Windows10"
pushd Additional\Windows10\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\Windows10" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\Windows10" >nul)
popd
pushd Extra\WithoutKB3125574\_Windows10\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\Windows10" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\Windows10" >nul)
popd
cd /d "%cab_dir%\Windows10"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\Windows10"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=Windows10 Updates
goto :listdone

:wmf
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
if not exist "%repo%\Additional\WMF\*.msu" goto :eof
if not exist "%target%\Windows\Microsoft.NET\Framework\v4.0.30319\ngen.exe" goto :eof
call :cleaner
title Processing WMF Updates
cls
md "%cab_dir%\WMF"
pushd Additional\WMF\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\WMF" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\WMF" >nul)
popd
pushd Extra\WithoutKB3125574\_WMF4\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\WMF" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\WMF" >nul)
popd
cd /d "%cab_dir%\WMF"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\WMF"
for /d %%G in (KB2872035,KB2872047,KB2809215) do (
if exist "*%%G*.cab" del "*%%G*.cab" >nul
)
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=WMF Updates
goto :listdone

:adlds
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
call :cleaner
title Processing ADLDS Updates
if exist "%target%\Windows\servicing\packages\*DirectoryServices-ADAM-Package-Client*7601*.mum" goto :eof
if exist "%target%\Windows\servicing\packages\*DirectoryServices-ADAM-Package-Client*.mum" (
call :adldsu
goto :eof
)
if not exist "%repo%\Extra\AD_LDS\*.msu" goto :eof
cd Extra\AD_LDS\
echo.
echo __________________________________________________________________
echo.
echo Installing AD LDS package
echo.
for /f %%i in ('dir /b *%arch%.msu') do expand.exe -f:*Windows*.cab %%i "%cab_dir%" >nul
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:"%cab_dir%"
call :adldsu
goto :eof

:adldsu
if not exist "%repo%\Extra\WithoutKB3125574\AD_LDS\*.msu" goto :eof
call :cleaner
cls
md "%cab_dir%\AD_LDS"
if exist "%repo%\Extra\AD_LDS\Updates\*.msu" (
pushd Extra\AD_LDS\Updates\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\AD_LDS" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\AD_LDS" >nul)
popd
)
pushd Extra\WithoutKB3125574\AD_LDS\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\AD_LDS" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\AD_LDS" >nul)
popd
cd /d "%cab_dir%\AD_LDS"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\AD_LDS"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=AD LDS Updates
goto :listdone

:rsat
if defined online if %allcount% geq %onlinelimit% (goto :countlimit)
call :cleaner
title Processing RSAT Updates
if exist "%target%\Windows\servicing\packages\*RemoteServerAdministrationTools*.mum" (
call :rsatu
goto :eof
)
if not exist "%repo%\Extra\RSAT\*.msu" goto :eof
cd Extra\RSAT\
echo.
echo __________________________________________________________________
echo.
echo Installing RSAT package
echo.
for /f %%i in ('dir /b *%arch%.msu') do expand.exe -f:*Windows*.cab %%i "%cab_dir%" >nul
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:"%cab_dir%"
call :rsatu
goto :eof

:rsatu
if not exist "%repo%\Extra\WithoutKB3125574\RSAT\*.msu" goto :eof
call :cleaner
cls
md "%cab_dir%\RSAT"
if exist "%repo%\Extra\RSAT\Updates\*.msu" (
pushd Extra\RSAT\Updates\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\RSAT" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\RSAT" >nul)
popd
)
pushd Extra\WithoutKB3125574\RSAT\
for /f "delims=" %%a in ('"dir /b *%arch%*.msu" 2^>nul') do (copy "%%a" "%cab_dir%\RSAT" >nul)
for /f "delims=" %%a in ('"dir /b *%arch%*.cab" 2^>nul') do (copy "%%a" "%cab_dir%\RSAT" >nul)
popd
cd /d "%cab_dir%\RSAT"
call :counter
set msu=1&set count=0
if %_msu% neq 0 (for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :cab))
if %_cab% neq 0 (set msu=0&set count=0&for /f %%G in ('dir /b *%arch%*.cab') do (set package=%%G&call :cab))
if %_sum% equ 0 goto :eof
set ldr=&set listc=0&set list=1&set AC=125&set count=0
cd /d "%cab_dir%"
rd /s /q "%cab_dir%\RSAT"
for /f %%G in ('dir /b /od *.cab') do (call :mum %%G)
set cat=RSAT Updates
goto :listdone

:online
if not exist "%repo%\Additional\_NotAllowedOffline\*.msu" goto :eof
call :cleaner
title Processing Exclusive online updates
cls
cd Additional\_NotAllowedOffline\
for /f %%G in ('dir /b *%arch%*.msu') do (set package=%%G&call :online2)
goto :eof

:online2
for /f "tokens=2 delims=-" %%V in ('dir /b %package%') do set kb=%%V
if /i %kb%==KB947821 goto :eof
if exist "%target%\Windows\servicing\packages\package_for_%kb%~*6.1*.mum" goto :eof
echo.
echo __________________________________________________________________
echo.
echo Installing %kb%
if /i %kb%==KB2533552 (
for /f %%i in ('dir /b *KB2533552*%arch%.msu') do expand.exe -f:*Windows*.cab %%i "%cab_dir%" >nul
"%dismroot%" %dismtarget% /NoRestart /Add-Package /packagepath:"%cab_dir%"
) else (
%package% /quiet /norestart
)
goto :eof

:: ##################################################################

:cab
cls
if defined online if %count% equ %onlinelimit% goto :eof
if /i %package% equ WUClient-SelfUpdate-ActiveX-%arch%-7.6.7600.320.cab (
if exist "%target%\Windows\servicing\packages\WUClient-SelfUpdate-ActiveX*7.6.7600.320.mum" (set /a _sum-=1&set /a _cab-=1&goto :eof) else (copy "%package%" "%cab_dir%" >nul&goto :eof)
)
if /i %package% equ WUClient-SelfUpdate-Aux-%arch%-7.6.7600.320.cab (
if exist "%target%\Windows\servicing\packages\WUClient-SelfUpdate-Aux*7.6.7600.320.mum" (set /a _sum-=1&set /a _cab-=1&goto :eof) else (copy "%package%" "%cab_dir%" >nul&goto :eof)
)
if /i %package% equ WUClient-SelfUpdate-Core-%arch%-7.6.7600.320.cab (
if exist "%target%\Windows\servicing\packages\WUClient-SelfUpdate-Core*7.6.7600.320.mum" (set /a _sum-=1&set /a _cab-=1&goto :eof) else (copy "%package%" "%cab_dir%" >nul&goto :eof)
)
for /f "tokens=2 delims=-" %%V in ('dir /b %package%') do set kb=%%V
if %IEcab% equ 1 for /f "tokens=3 delims=-" %%V in ('dir /b %package%') do set kb=%%V
if /i %kb%==%servicestack% (set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==%rollup% (set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB917607 (if exist "%target%\Windows\servicing\packages\*Winhelp-Update-Client*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB971033 (if exist "%target%\Windows\servicing\packages\*WindowsActivationTechnologies*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2670838 (if exist "%target%\Windows\servicing\packages\*PlatformUpdate-Win7-SRV08R2*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2592687 (if exist "%target%\Windows\servicing\packages\*RDP-WinIP-Package*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2830477 (if exist "%target%\Windows\servicing\packages\*RDP-BlueIP-Package*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB982861 (if exist "%target%\Windows\servicing\packages\*InternetExplorer*9.4.*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2841134 (if exist "%target%\Windows\servicing\packages\*InternetExplorer*11.2.*.mum" set /a _sum-=1&set /a _cab-=1&goto :eof)
if /i %kb%==KB2849696 (if exist "%target%\Windows\servicing\packages\*IE-Spelling-Parent-Package-English*11.2.*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2849697 (if exist "%target%\Windows\servicing\packages\*IE-Hyphenation-Parent-Package-English*11.2.*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2819745 (if exist "%target%\Windows\servicing\packages\*WinMan-WinIP*7.2.7601.*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB3134760 (if exist "%target%\Windows\servicing\packages\*WinMan-WinIP*7.3.7601.*.mum" set /a _sum-=1&set /a _msu-=1&goto :eof)
if /i %kb%==KB2872035 (if exist "%target%\Windows\servicing\packages\Package_for_KB2872035*.mum" set /a _sum-=1&set /a _cab-=1&goto :eof)
for /d %%G in %rdp8% do (
  if /i !kb!==%%G call set /a _sum-=1&call set /a _msu-=1&goto :eof
)
set inver=
if /i %kb%==%hv_integ_kb% if exist "%target%\Windows\servicing\packages\*Hyper-V-Integration-Services*.mum" (
echo.
echo Checking installed %kb% version
for /f "tokens=6,7 delims=~." %%i in ('dir /b /od "%target%\Windows\servicing\packages\*Hyper-V-Integration-Services*.mum"') do call set inver=%%i%%j
)
if defined inver (if !inver! GEQ !hv_integ_vr! (set /a _sum-=1&set /a _cab-=1&goto :eof))
set inver=
set "mumcheck=package_*_for_%kb%*6.1*.mum"
if /i %LDRbranch% neq ON set "mumcheck=package_*_for_%kb%~*6.1*.mum"
if %IEcab% equ 1 set "mumcheck=package_for_%kb%*.mum"
if /i %LDRbranch% neq ON if %IEcab% equ 1 set "mumcheck=package_for_%kb%~*.mum"
for /d %%G in %gdrlist% do (
  if /i !kb!==%%G call set "mumcheck=package_for_%kb%~*6.1*.mum"
)
if exist "%target%\Windows\servicing\packages\%mumcheck%" (
echo.
echo Checking installed %kb% version
for /f "tokens=6,7 delims=~." %%i in ('dir /b /od "%target%\Windows\servicing\packages\%mumcheck%"') do call set inver=%%i%%j
mkdir "%cab_dir%\check"
if %msu% equ 1 (expand.exe -f:*Windows*.cab %package% "%cab_dir%\check" >nul) else (copy %package% "%cab_dir%\check" >nul)
expand.exe -f:package_for_%kb%*.mum "%cab_dir%\check\*.cab" "%cab_dir%\check" >nul
for /f "tokens=6,7 delims=~." %%i in ('dir /b "%cab_dir%\check\package_for_%kb%*.mum"') do call set kbver=%%i%%j
rd /s /q "%cab_dir%\check"
)
if defined inver (if !inver! GEQ !kbver! (set /a _sum-=1&set /a _msu-=1&goto :eof))
set /a count+=1
echo.
if %msu% equ 1 (echo Extracting .cab files from .msu files) else (echo Copying .cab files to temp folder)
echo __________________________________________________________________
echo.
echo.
if %msu% equ 1 (echo %count% of %_msu%: %package%) else (echo %count% of %_cab%: %package%)
if %msu% equ 1 (expand.exe -f:*Windows*.cab %package% "%cab_dir%" >nul) else (copy %package% "%cab_dir%" >nul)
if /i %kb%==KB2849696 ren "%cab_dir%\Windows6.3-KB2849696-x86.cab" IE11-Windows6.1-KB2849696-%arch%.cab
if /i %kb%==KB2849697 ren "%cab_dir%\Windows6.3-KB2849697-x86.cab" IE11-Windows6.1-KB2849697-%arch%.cab
goto :eof

:mum
if %listc% geq %ac% (set /a AC+=125&set /a list+=1&set ldr%list%=%ldr%&set ldr=)
set package=%1
set dist=%~n1
set /a count+=1
set /a allcount+=1
set /a listc+=1
cls
echo.
echo Extracting files from update cabinets (.cab)
echo *** This will require some disk space, please be patient ***
echo __________________________________________________________________
echo.
echo.
echo %count% of %_sum%: %package%
md "%dist%"
expand.exe -f:* "%package%" "%dist%" 1>nul 2>nul || (set ldr=!ldr! /packagepath:%package%&goto :eof)
if /i %LDRbranch% neq ON (set ldr=!ldr! /packagepath:%dist%\update.mum&goto :eof)
for /f "tokens=2 delims=-" %%V in ('dir /b %package%') do set kb=%%V
for /d %%G in %gdrlist% do (
  if /i !kb!==%%G call set ldr=!ldr! /packagepath:%dist%\update.mum&goto :eof
)
if exist "%dist%\update-bf.mum" (set ldr=!ldr! /packagepath:%dist%\update-bf.mum) else (set ldr=!ldr! /packagepath:%dist%\update.mum)
goto :eof

:listdone
if %listc% lss %ac% (set ldr%list%=%ldr%)
set lc=1
cls
echo.
echo Now installing Updates...
echo __________________________________________________________________
echo.

:PP
if %lc% gtr %list% goto :eof
call set ldr=%%ldr%lc%%%
set ldr%lc%=
Title %listc% %cat%, session %lc% of %list%
"%dismroot%" %dismtarget% /NoRestart /Add-Package %ldr%
set /a lc+=1
goto :PP

:cleaner
cd /d "%repo%"
if exist "%cab_dir%" (echo.&echo Please wait whilst temporary install files are removed...&rd /s /q "%cab_dir%"&echo.)
if not exist "%cab_dir%" md "%cab_dir%"
goto :eof

:counter
set _msu=0
set _cab=0
set _sum=0
if exist "*%arch%*.msu" (for /f %%a in ('dir /b *%arch%*.msu') do (call set /a _msu+=1))
if exist "*%arch%*.cab" (for /f %%a in ('dir /b *%arch%*.cab') do (call set /a _cab+=1))
set /a _sum=%_msu%+%_cab% >nul
goto :eof

:win10u
title Processing Windows10 Block tweaks
cls
set _schtasks=%windir%\system32\schtasks.exe
if defined online (set ksub1=SOFTWARE&set ksub2=SYSTEM) else (set ksub1=OFFSOFT&set ksub2=OFFSYST)
if not defined online (
%_reg% load HKLM\%ksub1% "%target%\Windows\System32\config\SOFTWARE" >nul
%_reg% load HKLM\%ksub2% "%target%\Windows\System32\config\SYSTEM" >nul
)
%_reg% add HKLM\%ksub2%\ControlSet001\Services\DiagTrack /v Start /t REG_DWORD /d 4 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Policies\Microsoft\Windows\Gwx /v DisableGwx /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Policies\Microsoft\Windows\WindowsUpdate /v DisableOSUpgrade /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade /v AllowOSUpgrade /t REG_DWORD /d 0 /f 1>nul 2>nul
%_reg% add HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade /v ReservationsAllowed /t REG_DWORD /d 0 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /f /v IncludeRecommendedUpdates /t REG_DWORD /d 0 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Appraiser" /v HaveUploadedForTarget /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\AIT" /v AITEnable /t REG_DWORD /d 0 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\ClientTelemetry" /v DontRetryOnError /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\ClientTelemetry" /v IsCensusDisabled /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\ClientTelemetry" /v TaskEnableRun /t REG_DWORD /d 1 /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\AppCompatFlags" /v UpgradeEligible /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v OSUpgradePendingReboot /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\RebootRequired" /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\Volatile" /v OSUpgradeStartTime /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade" /v AutoRebootDelay /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade" /v KickoffDownload /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade" /v KickoffUpgrade /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\OSUpgrade\State" /f 1>nul 2>nul
%_reg% delete "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\WindowsUpdate\Reporting\EventCache.v2\Legacy\9482f4b4-e343-43b6-b170-9a65bc822c77" /f 1>nul 2>nul
if not defined online (
%_reg% unload HKLM\%ksub1% >nul
%_reg% unload HKLM\%ksub2% >nul
goto :eof
)
%_schtasks% /Change /TN "\Microsoft\Windows\Application Experience\Microsoft Compatibility Appraiser" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Application Experience\ProgramDataUpdater" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Application Experience\AitAgent" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\launchtrayprocess" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfig" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfigandcontent" /DISABLE >nul 2>&1
%_schtasks% /Change /TN "\Microsoft\Windows\Setup\gwx\refreshgwxcontent" /DISABLE >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Application Experience\Microsoft Compatibility Appraiser" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Application Experience\ProgramDataUpdater" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Application Experience\AitAgent" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\launchtrayprocess" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfig" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\refreshgwxconfigandcontent" >nul 2>&1
%_schtasks% /Delete /F /TN "\Microsoft\Windows\Setup\gwx\refreshgwxcontent" >nul 2>&1
(echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\refreshgwxconfig-B" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-URT" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\MachineUnlock-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfIdle-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfSleep-5d" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeReminderTime" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeTime" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Telemetry-4xd" /DISABLE
echo schtasks /Change /TN "\Microsoft\Windows\Setup\GWXTriggers\Time-5d" /DISABLE
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\refreshgwxconfig-B"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Logon-URT"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\MachineUnlock-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfIdle-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\OutOfSleep-5d"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeReminderTime"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\ScheduleUpgradeTime"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Telemetry-4xd"
echo schtasks /Delete /F /TN "\Microsoft\Windows\Setup\GWXTriggers\Time-5d")>%windir%\Tasks.cmd
%_schtasks% /Create /F /RU "SYSTEM" /RL HIGHEST /SC HOURLY /TN Tasks /TR "cmd /c %windir%\Tasks.cmd" >nul 2>&1
%_schtasks% /Run /I /TN Tasks >nul 2>&1
TIMEOUT /T 5 >nul 2>&1
%_schtasks% /Delete /F /TN Tasks >nul 2>&1
del /f /q %windir%\Tasks.cmd >nul 2>&1
%windir%\system32\sc.exe config DiagTrack start= disabled 1>nul 2>nul
%windir%\system32\sc.exe stop DiagTrack 1>nul 2>nul
del /f /q %ProgramData%\Microsoft\Diagnosis\*.rbs >nul 2>&1
del /f /q /s %ProgramData%\Microsoft\Diagnosis\ETLLogs\* >nul 2>&1
goto :eof

:regfix
if exist "%target%\Windows\WHD-regfix.txt" goto :eof
title Processing additional registry fixes
cls
if defined online (set ksub1=SOFTWARE&set ksub2=SYSTEM) else (set ksub1=OFFSOFT&set ksub2=OFFSYST)
if not defined online (
%_reg% load HKLM\%ksub1% "%target%\Windows\System32\config\SOFTWARE" >nul
%_reg% load HKLM\%ksub2% "%target%\Windows\System32\config\SYSTEM" >nul
)
%_reg% add "HKLM\%ksub1%\Microsoft\Cryptography\Calais" /f /v "TransactionTimeoutDelay" /t REG_DWORD /d 5 >nul
%_reg% add "HKLM\%ksub1%\Microsoft\Cryptography\OID\EncodingType 0\CertDllCreateCertificateChainEngine\Config" /f /v "MinRsaPubKeyBitLength" /t REG_DWORD /d 512 >nul
%_reg% add "HKLM\%ksub1%\Microsoft\Cryptography\OID\EncodingType 0\CertDllCreateCertificateChainEngine\Config" /f /v "EnableWeakSignatureFlags" /t REG_DWORD /d 2 >nul
%_reg% add "HKLM\%ksub1%\Microsoft\MSMQ\Parameters" /f /v "IgnoreOSNameValidationForReceive" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\Policies\System" /f /v "EnableLinkedConnections" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows\CurrentVersion\Policies\System" /f /v "InteractiveLogonFirst" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub1%\Microsoft\Windows NT\CurrentVersion\Windows" /f /v "UMPDSecurityLevel" /t REG_DWORD /d 2 >nul
%_reg% add "HKLM\%ksub1%\Policies\Group Policy" /f /v "PurgeRSOP" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub1%\Policies\Microsoft\Netlogon\Parameters" /f /v "AddressLookupOnPingBehavior" /t REG_DWORD /d 2 >nul
%_reg% add "HKLM\%ksub1%\Policies\Microsoft\Windows\Group Policy" /f /v "EnableLocalStoreOverride" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub1%\Policies\Microsoft\Windows\Installer" /f /v "NoUACforHashMissing" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub1%\Policies\Microsoft\Windows\SmartCardCredentialProvider" /f /v "AllowVirtualSmartCardPinChangeAndUnlock" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\BFE\Parameters" /f /v "MaxEndpointCountMult" /t REG_DWORD /d 10 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\CSC\Parameters" /f /v "FormatDatabase" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\LanmanServer\Parameters" /f /v "ABELevel" /t REG_DWORD /d 2 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\LanmanServer\Parameters" /f /v "AsynchronousCredits" /t REG_DWORD /d 4132 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\LanmanServer\Parameters" /f /v "DisableStrictNameChecking" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\LanmanServer\Parameters" /f /v "OptionalNames" /t REG_SZ /d aliasname >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\LanmanWorkstation\Parameters" /f /v "ExtendedSessTimeout" /t REG_DWORD /d 1152 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\MRxDAV\Parameters" /f /v "FsCtlRequestTimeoutInSec" /t REG_DWORD /d 3600 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\WebClient\Parameters" /f /v "EnableCTLFiltering" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\WebClient\Parameters" /f /v "EnableAutoCertSelection" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\RemoteAccess\Parameters\Ip" /f /v "DisableMulticastForwarding" /t REG_DWORD /d 0 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Services\usbhub\HubG" /f /v "DisableOnSoftRemove" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\CrashControl" /f /v "MaxSecondaryDataDumpSize" /t REG_DWORD /d 4294967295 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\Print" /f /v "DnsOnWire" /t REG_DWORD /d 1 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\Print" /f /v "SplWOW64TimeOutSeconds" /t REG_DWORD /d 576 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\Pnp" /f /v "BootOptions" /t REG_DWORD /d 0 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\Pnp" /f /v "DisableCDDB" /t REG_DWORD /d 0 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\Pnp" /f /v "DontStartRawDevices" /t REG_DWORD /d 0 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\PnP" /f /v "PollBootPartitionTimeout" /t REG_DWORD /d 120000 >nul
%_reg% add "HKLM\%ksub2%\ControlSet001\Control\usbstor\054C00C1" /f /v "MaximumTransferLength" /t REG_DWORD /d 2097120 >nul
if not defined online (
%_reg% unload HKLM\%ksub1% >nul
%_reg% unload HKLM\%ksub2% >nul
)
if exist "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\*" (
attrib -S -I "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\Microsoft\CryptnetUrlCache" 1>nul 2>nul
for /f %%i in ('dir /b /s /as "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\Microsoft\CryptnetUrlCache\*"') do (attrib -S -I "%%i" 1>nul 2>nul)
DEL /S /F /Q "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\Microsoft\CryptnetUrlCache\Content\*" 1>nul 2>nul
DEL /S /F /Q "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\Microsoft\CryptnetUrlCache\MetaData\*" 1>nul 2>nul
for /f %%i in ('dir /b /s "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\Microsoft\CryptnetUrlCache\*"') do (attrib +S "%%i" 1>nul 2>nul)
attrib +S "%target%\Windows\ServiceProfiles\LocalService\AppData\LocalLow\Microsoft\CryptnetUrlCache" 1>nul 2>nul
)
if exist "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\*" (
attrib -S -I "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\Microsoft\CryptnetUrlCache" 1>nul 2>nul
for /f %%i in ('dir /b /s /as "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\Microsoft\CryptnetUrlCache\*"') do (attrib -S -I "%%i" 1>nul 2>nul)
DEL /S /F /Q "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\Microsoft\CryptnetUrlCache\Content\*" 1>nul 2>nul
DEL /S /F /Q "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\Microsoft\CryptnetUrlCache\MetaData\*" 1>nul 2>nul
for /f %%i in ('dir /b /s "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\Microsoft\CryptnetUrlCache\*"') do (attrib +S "%%i" 1>nul 2>nul)
attrib +S "%target%\Windows\ServiceProfiles\NetworkService\AppData\LocalLow\Microsoft\CryptnetUrlCache" 1>nul 2>nul
)
if exist "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\*" (
attrib -S -I "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\Microsoft\CryptnetUrlCache" 1>nul 2>nul
for /f %%i in ('dir /b /s /as "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\Microsoft\CryptnetUrlCache\*"') do (attrib -S -I "%%i" 1>nul 2>nul)
DEL /S /F /Q "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\Microsoft\CryptnetUrlCache\Content\*" 1>nul 2>nul
DEL /S /F /Q "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\Microsoft\CryptnetUrlCache\MetaData\*" 1>nul 2>nul
for /f %%i in ('dir /b /s "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\Microsoft\CryptnetUrlCache\*"') do (attrib +S "%%i" 1>nul 2>nul)
attrib +S "%target%\Windows\System32\config\systemprofile\AppData\LocalLow\Microsoft\CryptnetUrlCache" 1>nul 2>nul
)
echo cookie>"%target%\Windows\WHD-regfix.txt"
goto :eof

:stacklimit
title Installer for Windows Updates
cls
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo.
echo Installation of servicing %servicestack% require no pending update operation.
echo ____________________________________________________________________________
echo.
echo please restart the system
echo after the reboot, run the script again.
echo.
echo.
echo Press any key to Exit
pause >nul
exit

:countlimit
title Installer for Windows Updates
cls
call :cleaner
cls
echo      ---------
echo  *** ATTENTION ***
echo      ---------
echo.
echo.
echo %onlinelimit% or more updates had been installed
echo installing further more will make the process extremely slow.
echo ____________________________________________________________________________
echo.
echo please restart the system now
echo after the reboot, rerun the script to install other updates.
echo.
echo.
echo Press any key to Exit
pause >nul
exit

:fin
title Installer for Windows Updates
cls
echo.
cd /d "%~dp0"
echo.
echo.
if exist "%cab_dir%" (echo Please wait whilst temporary install files are removed...&rd /s /q "%cab_dir%"&echo.)
echo ############################################################################
echo.
echo    Finished
echo.
if defined online if exist "%windir%\winsxs\pending.xml" (echo.&echo System restart is required.)
echo.
echo Press any key to exit.
pause >nul
goto :eof
